



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[Tensorflow] RNN - 04. Work with CNN for Text Classification</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[Tensorflow] RNN - 04. Work with CNN for Text Classification</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 19:57:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p>Ref:&nbsp;<a href="https://yerevann.github.io/2016/06/26/combining-cnn-and-rnn-for-spoken-language-identification/" rel="external nofollow noreferrer">Combining CNN and RNN for spoken language identification</a></p>
<p>Ref:&nbsp;<a href="https://medium.com/@TalPerry/convolutional-methods-for-text-d5260fd5675f" rel="external nofollow noreferrer">Convolutional Methods for&nbsp;Text</a></p>
<p><strong><em>[1]&nbsp;<a href="http://static.googleusercontent.com/media/research.google.com/en//pubs/archive/43455.pdf" rel="external nofollow noreferrer">CONVOLUTIONAL, LONG SHORT-TERM MEMORY, FULLY CONNECTED DEEP NEURAL NETWORKS</a></em></strong></p>
<p><em><strong>[2]&nbsp;<a href="https://arxiv.org/abs/1602.00367v1" rel="external nofollow noreferrer">Efficient Character-level Document Classification by Combining Convolution and Recurrent Layers</a></strong></em></p></blockquote>
<p>结合此文，对sentiment prediction做进一步的性能提升。</p>
<p>一个近似的例子：<a href="https://github.com/LopezGG/NN_NER_tensorFlow/blob/master/network.py" rel="external nofollow noreferrer">https://github.com/LopezGG/NN_NER_tensorFlow/blob/master/network.py</a></p>
<div>
<pre class="prettyprint linenums">       #Embedding layer (is always built on CPU. There is bug that makes embedding fail on GPU)<br />
        with tf.device('/cpu:0'), tf.name_scope("char_embedding"):<br />
            #plus 1 becuase 0 is for unknown char<br />
            self.W_char = tf.Variable(tf.random_uniform([char_vocab_size+1, char_embedd_dim],-1,1),trainable=True, name="W_char")<br />
            self.char_embedding_placeholder = tf.placeholder(tf.float32, [char_vocab_size+1, char_embedd_dim])<br />
            char_embedding_init = self.W_char.assign(self.char_embedding_placeholder)<br />
            self.embedded_char = tf.nn.<strong>embedding_lookup</strong>(self.W_char, self.input_x_char_flat,name="embedded_char") #shape [batch_size,max_char_per_word*sequence_length,char_embedd_dim]<br />
            self.<strong>embedded_char_dropout</strong> =tf.nn.dropout(self.embedded_char, self.dropout_keep_prob,name="embedded_char_dropout")<br />
        #Add CNN get filters and combine with word<br />
        with tf.name_scope("char_conv_maxPool"):<br />
            filter_shape = [<strong>filter_size, char_embedd_dim,　num_filters</strong>]<br />
            W_conv = tf.Variable(tf.truncated_normal(filter_shape, stddev=0.1), name="W_conv")<br />
            b_conv = tf.Variable(tf.constant(0.1, shape=[num_filters]), name="b_conv")

            conv = tf.nn.<strong>conv1d</strong>(self.<strong>embedded_char_dropout</strong>,<br />
                        W_conv,<br />
                        stride=1,<br />
                        padding="SAME",<br />
                        name="conv") #will have dimensions [batch_size,out_width,num_filters] out_width is a function of max_words,filter_size and stride_size #(?, 3051, 20)<br />
            #out_width for same padding iwth stride 1  given by (max_char_per_word*sequence_length)<br />
            print("conv.get_Shape(): ",conv.get_shape())<br />
            # Apply nonlinearity TODO: Test without relu<br />
            #h = tf.nn.bias_add(conv, b_conv,name="add bias")#does not change dimensions<br />
            h_expand = tf.expand_dims(conv, -1)<br />
            print("h_expand.get_Shape(): ",h_expand.get_shape())<br />
            pooled = tf.nn.<strong>max_pool</strong>(<br />
                        h_expand,<br />
                        #[batch, height, width, channels]<br />
                        ksize=[1,sequence_length * max_char_per_word,1, 1], #On the batch size dimension and the channels dimension, ksize is 1 because we don't want to take the maximum over multiple examples, or over multiples channels.<br />
                        strides=[1, max_char_per_word, 1, 1],<br />
                        padding='SAME',<br />
                        name="pooled")<br />
            #print("pooled.get_Shape(): ",pooled.get_shape())<br />
            #[batch_size,(max_char_per_word*sequence_length), num_filters, 1] --&gt; [batch, sequence_length, num_filters] , same as word_embedding layer (?, 113, 20, 1) --&gt; (?, 113, 20)<br />
            self.char_pool_flat = tf.reshape(pooled, [-1,sequence_length,num_filters],name="char_pool_flat")<br />
            #print("self.char_pool_flat.get_shape(): ",self.char_pool_flat.get_shape())<br />
            #[batch, sequence_length, word_embedd_dim+num_filters]<br />
            self.word_char_features = tf.concat([self.embedded_words, self.char_pool_flat], axis=2) #we mean that the feature with index 2 i/e num_filters is variable<br />
            #print("self.word_char_features.get_shape(): ",self.word_char_features.get_shape())<br />
            self.word_char_features_dropout =tf.nn.dropout(self.word_char_features, self.dropout_keep_prob,name="word_char_features_dropout")</pre>
</div>
<h3>Combinations of CNN and RNN</h3>
<p>The general architecture of these combinations is a convolutional feature extractor applied on the input, then some recurrent network on top of the CNN&rsquo;s output, then an optional fully connected layer on RNN&rsquo;s output and finally a softmax layer.</p>
<p>The output of the CNN is a set of several channels (also known as&nbsp;<em>feature maps</em>). We can have separate GRUs acting on each channel (with or without weight sharing) as described in this picture (Left).</p>
<p>Another option is to interpret CNN&rsquo;s output as a 3D-tensor and run a single GRU on 2D slices of that tensor, picture (Right).</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/310015/201710/310015-20171007130641286-834186341.png" /></p>
<p>The latter option has more parameters,but the information from different channels is mixed inside the GRU, and it seems to <strong>improve performance. 【后者貌似好】</strong></p>
<p>This architecture is similar to the one described in&nbsp;<a href="http://static.googleusercontent.com/media/research.google.com/en//pubs/archive/43455.pdf" rel="external nofollow noreferrer">this paper</a>[1]&nbsp;on speech recognition,</p>
<p>except that they also use some residual connections (&ldquo;shortcuts&rdquo;) from input to RNN and from CNN to fully connected layers.</p>
<p>It is interesting to note that recently it was shown that similar architectures work well for&nbsp;<a href="http://arxiv.org/abs/1602.00367" rel="external nofollow noreferrer">text classification</a>[2].</p>
<table>
<thead>
<tr>
<th>Network</th>
<th>Accuracy</th>
<th>Notes</th>
</tr>
</thead>
<tbody>
<tr>
<td><a href="https://github.com/YerevaNN/Spoken-language-identification/blob/master/theano/networks/tc_net_rnn.py" rel="external nofollow noreferrer">tc_net_rnn</a></td>
<td>92.4</td>
<td>CNN consists of 3 convolutional blocks and outputs 32 channels of size 104x13. Each of these channels is fed to a separate GRU as a sequence of 104 vectors of size 13. The outputs of GRUs are combined and fed to a fully connected layer</td>
</tr>
<tr>
<td><a href="https://github.com/YerevaNN/Spoken-language-identification/blob/master/theano/networks/tc_net_rnn_nodense.py" rel="external nofollow noreferrer">tc_net_rnn_nodense</a></td>
<td>91.94</td>
<td>Same as above, except there is no fully connected layer on top of GRUs. Outputs of GRU are fed directly to the softmax layer</td>
</tr>
<tr>
<td><a href="https://github.com/YerevaNN/Spoken-language-identification/blob/master/theano/networks/tc_net_rnn_shared.py" rel="external nofollow noreferrer">tc_net_rnn_shared</a></td>
<td>96.96</td>
<td>Same as above, but the 32 GRUs share weights. This helped to fight overfitting</td>
</tr>
<tr>
<td><a href="https://github.com/YerevaNN/Spoken-language-identification/blob/master/theano/networks/tc_net_rnn_shared_pad.py" rel="external nofollow noreferrer">tc_net_rnn_shared_pad</a></td>
<td>98.11</td>
<td>4 convolutional blocks in CNN using&nbsp;<code>pad=2</code>&nbsp;instead of&nbsp;<code>ignore_broder=False</code>(which enabled CuDNN and the training became much faster). The output of CNN is a set of 32 channels of size 54x8. 32 GRUs are applied (one for each channel) with shared weights and there is no fully connected layer</td>
</tr>
<tr>
<td><a href="https://github.com/YerevaNN/Spoken-language-identification/blob/master/theano/networks/tc_net_deeprnn_shared_pad.py" rel="external nofollow noreferrer">tc_net_deeprnn_shared_pad</a></td>
<td>95.67</td>
<td>4 convolutional block as above, but 2-layer GRUs with shared weights are applied on CNN&rsquo;s outputs. Overfitting became stronger because of this second layer</td>
</tr>
<tr>
<td><a href="https://github.com/YerevaNN/Spoken-language-identification/blob/master/theano/networks/tc_net_shared_pad_augm.py" rel="external nofollow noreferrer">tc_net_shared_pad_augm</a></td>
<td>98.68</td>
<td>Same as&nbsp;<a href="https://github.com/YerevaNN/Spoken-language-identification/blob/master/theano/networks/tc_net_rnn_shared_pad.py" rel="external nofollow noreferrer">tc_net_rnn_shared_pad</a>, but the network randomly crops the input and takes 9s interval. The performance became a bit better due to this</td>
</tr>
<tr>
<td><a href="https://github.com/YerevaNN/Spoken-language-identification/blob/master/theano/networks/tc_net_rnn_onernn.py" rel="external nofollow noreferrer">tc_net_rnn_onernn</a></td>
<td>99.2</td>
<td>The outputs of a CNN with 4 convolutional blocks are grouped into a 32x54x8 3D-tensor and <strong>a single GRU</strong> runs on a sequence of 54 vectors of size 32*8</td>
</tr>
<tr>
<td><a href="https://github.com/YerevaNN/Spoken-language-identification/blob/master/theano/networks/tc_net_rnn_onernn_notimepool.py" rel="external nofollow noreferrer">tc_net_rnn_onernn_notimepool</a></td>
<td><strong>99.24</strong></td>
<td>Same as above, but the stride along the time axis is set to 1 in every pooling layer. Because of this the CNN outputs 32 channels of size 852x8</td>
</tr>
</tbody>
</table>
<p><strong>The second layer of GRU</strong> in this setup didn&rsquo;t help due to the overfitting.</p>
<p>It seems that subsampling in the time dimension is not a good idea. <strong>The information that is lost during subsampling</strong> can be better used by the RNN.</p>
<p>In the&nbsp;<a href="http://arxiv.org/abs/1602.00367v1" rel="external nofollow noreferrer">paper on text classification</a>[2]&nbsp;by Yijun Xiao and Kyunghyun Cho, the authors even suggest that maybe <strong>all pooling/subsampling layers can be replaced</strong> by recurrent layers.</p>
<p><strong>训练技巧</strong></p>
<p>These networks were trained using <strong>SGD with momentum only</strong>. The learning rate was set to <strong>0.003 for around 10 epochs</strong>, then it was <strong>manually</strong> decreased to <strong>0.001</strong> and then to <strong>0.0003</strong>. On average, it took <strong>35 epochs</strong> to train these networks.</p>
<h3>Ensembling</h3>
<p>The best single model had <strong>99.24%</strong> accuracy on the validation set. We had 33 predictions by all these models (there were more than one predictions for some models, taken after different epochs) and we just summed up the predicted probabilities and got 99.67% accuracy. Surprisingly, our other attempts of ensembling (e.g.&nbsp;<a href="http://www.scholarpedia.org/article/Ensemble_learning#Voting_based_methods" rel="external nofollow noreferrer">majority voting</a>, ensemble only on some subset of all models) didn&rsquo;t give better results.</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49541mqz.html">JDK动态代理实现原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/390vwxm8.html">Libero 使用拾忆</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kxrr3q.html">access的逻辑类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwddl4r8.html">装了maven插件的eclipse中M2&lowbar;REPO无法编辑、删除（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vm1yj8.html">Eclipse中设置JDK内存方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wk3wlq.html">SDUST作业10 Problem J&colon; 提取缩略词</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y0e2nq.html">模仿TMALL搜索，下拉提示  优化  用户keypress停顿200毫秒间隔时，在执行异步取数据操作   通过underscore的函数debounce来实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1675zq.html">C&num; 处理PPT水印（一）&mdash;&mdash;添加水印效果（文字水印、图片水印）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wo10gq.html">springboot秒杀课程学习整理1-4</a>
		</li>
						<li><a href="https://www.batexi.com/a/9607gy49.html">32&period; Springboot 系列（八）动态Banner与图片转字符图案的手动实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wnwnrq.html">IIS环境下部署https【转载】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1v03w9.html">three&period;js 第二篇&colon;场景 相机 渲染器 物体之间的关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r05308.html">C&plus;&plus; 关于MFC  List Control  控件的使用事项 原创</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jx60eq.html">踏破铁鞋无觅处，从AsyncTask学Android线程池</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjw60j9.html">从MS Word到Windows Live Writer</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4je6xjq.html">如何解决WEB应用中文乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjmrr68.html">20155336 虎光元《网络攻防》Exp2后门原理与实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k0ovoq.html">android自定义tabhost&comma;tabcontent用intent获得</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk31ox8.html">2018&period;07&period;08 hdu5316 Magician（线段树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9025p5mq.html">Django进阶 &lpar;二&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyyngw2q.html">php 去重</a>
			</li>
						<li><a href="https://www.batexi.com/a/95glz3eq.html">Java 对象的序列化和反序列化</a>
			</li>
						<li><a href="https://www.batexi.com/a/95glzj6q.html">nginx image&lowbar;filter 配置记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2p7oo9.html">C&plus;&plus;并发编程 条件变量 condition&lowbar;variable，线程安全队列示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r016m9.html">Autonomous driving - Car detection YOLO</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1pom1q.html">AI通过了艺术创作图灵测试，你根本分不出来作者是不是人</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyynlrgq.html">ios mac 对照片进行JPEG压缩</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e467jk9.html">微软BI 之SSIS 系列 - 在 SSIS 中将指定目录下的所有文件分类输出到不同文件夹</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw13vz9.html">从网上找的Android实用代码，记录备用</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gll3vq.html">Jquery计算时间戳之间的差值，可返回年，月，日，小时等</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
